/*
  LcdUi.h

  User interface on LCD displays.

  release : 0.0.0 - 7 April 2011

  ------------------------------------------------------------------------------
  Copyright (c) 2011 Wim Langers.  All right reserved.

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
  ------------------------------------------------------------------------------
*/

#ifndef LcdUi_h
#define LcdUi_h
#include <Arduino.h>
#include <LiquidCrystal.h>
#include "utility/LcdKey.h"
#include "utility/LcdMenus.h"
class LcdUi
{
  public:
    LcdUi(uint8_t width,uint8_t height,uint8_t rs,uint8_t rw,uint8_t enable,uint8_t d0,uint8_t d1,uint8_t d2, uint8_t d3, uint8_t d4,uint8_t d5, uint8_t d6, uint8_t d7);
    LcdUi(uint8_t width,uint8_t height,uint8_t rs,uint8_t enable,uint8_t d0,uint8_t d1,uint8_t d2, uint8_t d3, uint8_t d4,uint8_t d5, uint8_t d6, uint8_t d7);
    LcdUi(uint8_t width,uint8_t height,uint8_t rs,uint8_t enable,uint8_t d4,uint8_t d5, uint8_t d6, uint8_t d7);
    void    init(PGM_VOID_P DEF,char* data,uint8_t pin,uint16_t debounce,uint16_t delay,uint8_t repeat,uint8_t exit);
    LCDKEY  refresh();
    void    screen();
  private:
    uint8_t         m_height;
    LiquidCrystal   m_lcd;
    LcdMenus        m_menus;
    uint8_t         m_width;
};
#endif
