/*
  LcdMenu.c

  release : 0.0.1 - 23 Jan 2013

  ------------------------------------------------------------------------------
  Copyright (c) 2011, 2013 Wim Langers.  All right reserved.

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
  ------------------------------------------------------------------------------
*/

#include "LcdMenu.h"

/*
  Edit menu.
  Remark :
  Placeholder/dummy/convenience function.

  parameters :
  key       key to process
  menu      menu data
  return    key, if not consumed or if menu changed
            LCDKEY_NONE otherwise
*/
LCDKEY LcdMenuEdit(LCDKEY key,LcdMenu* menu) {
  key = LcdFieldsEdit(key,&menu->fields);
  menu->status = menu->fields.status;
  return key;
}

/*
  Get menu data for display.

  parameters :
  init    initialise pointers
  menu    menu data
*/
char LcdMenuGet(LcdMenu* menu,boolean init) {
  if (init) {
    menu->pptr = 4;
    menu->dptr = 0;
    return;
  }
  char c = pgm_read_byte(menu->DEF + menu->pptr);
  if (c == '~') {
    c = menu->fields.data[menu->dptr];
    if (menu->dptr == menu->fields.cursor) menu->cursor = menu->pptr - 4;
    ++menu->dptr;
  }
  ++menu->pptr;
  return c;
}

/*
  Initialise menu.

  parameters :
  init    initialise data
  menu    menu data
*/
void LcdMenuInit(LcdMenu* menu,boolean init) {
  memcpy_P(menu,menu->DEF,4); //left up down right
  LcdFieldsInit(&menu->fields,init);
  menu->status = menu->fields.status;
}
