/*
  LcdString.h
  String conversions.
  Primarily ment for LCD display.
  Remark :
  the resulting strings are never zero terminated

  release : 0.0.1 - 23 Jan 2013

  ------------------------------------------------------------------------------
  Copyright (c) 2011, 2013 Wim Langers.  All right reserved.

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
  ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef LcdString_h
#define LcdString_h
#include <Arduino.h>
#include "LcdTime.h"
void      LcdStringDtos(LcdTime* dt,char* data);
void      LcdStringItos(uint16_t number,char* data,uint8_t length);
uint8_t   LcdStringStob(char* data,uint8_t length);
uint8_t   LcdStringStob_P(PGM_P DATA,uint8_t length);
void      LcdStringStod(char* data,LcdTime* dt);
void      LcdStringStod_P(PGM_P DATA,LcdTime* dt);
int16_t   LcdStringStoi(char* data,uint8_t length);
int16_t   LcdStringStoi_P(PGM_P DATA,uint8_t length);
void      LcdStringStot(char* data,LcdTime* dt);
void      LcdStringStot_P(PGM_P DATA,LcdTime* dt);
void      LcdStringTtos(LcdTime* dt,char* data);
#endif

#ifdef __cplusplus
}
#endif
